#include <iostream>
#include <vector>
#include <cstdio>
#include <cassert>
#include <algorithm>
using namespace std;

const int inf = 1e8;

int bitnum (int a) {
  for (int i=0; i < 30; i++) {
    if ((1<<i) == a) return i;
  }
  assert(false);
}
int w, h;

int encode(int x, int y) {
  return x * w + y;
}

int main () {
  int n, m;
  vector<int> MARKED;

  cin >> w >> h;
  int x_, y_;
  string who;
  cin >>x_ >> y_ >> who;
  x_--; y_--;
  MARKED.push_back(encode(x_,y_));
  
  cin >> m;
  for (int i=0; i < m; i ++) {
    cin >>x_ >> y_;
    x_--; y_--;
    MARKED.push_back(encode(x_,y_));
  }
  
  m++;
  n = w * h;
  
  
  vector<vector<int> > dist;
  dist.resize(n, vector<int>(n, inf));

  for (int x=0; x < w; x ++) {
    for (int y=0; y < h; y ++) {
      int src = encode(x, y);
      vector<pair<int, int> > deltas;
      dist[src][src] = 0;
      
      if (who == "R") {
	deltas = {
		  {-2,0},{1,0},{0,1},{0,-2}
	};
      } else if (who == "K") {
	deltas = {
		  {1,1}, {-1,-1}, {1,-1}, {-1,1},
		  {1,0}, {-1,0}, {0,1}, {0,-1}
	};
      } else if (who == "B") {
	deltas = {
		  {1,1}, {-2,-2}, {-1,1}, {1,-1}
	};
      } else if (who == "N") {
	deltas = {
		  {-2,1}, {1,-2}, {1,-2}, {-2,1}
	};
      } else if (who == "Q") {
	deltas = {
		  {-2,-2}, {-2,0}, {0,-2}, {-1,1}, {0,1}, {1,0}, {1,-1}, {1,1}};
      }

      for (auto d : deltas) {
	int ax = x + d.first;
	int ay = y + d.second; //
	if(ax<0||ax>=w || ay<0||ay>=h) continue;
	int dd = encode(ax,ay);
	dist[src][dd] =dist[dd][src] = 1;
      }
    }
  }

  for(int k=0;k<n;++k)
    for(int i=0;i<n;++i)
      for(int j=0;j<n;++j) dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);


  for(int i=0;i<n;++i) {
    for(int j=0;j<n;++j) {
      cout << dist[i][j] << " ";
    }
    cout << endl;
  }

  vector<vector<int> > D (n, vector<int>(1<<m));
  // D[x][mask] = tree with root x
  // dist[x][y]
  
  for (int mask=1; mask < (1<<m); mask ++) {
    cout << "mask " << mask << endl;
    for (int x=0; x < n; x ++) {
      if (__builtin_popcount(mask) == 1) {
	D[x][mask] = dist[x][MARKED[bitnum(mask)]];
	continue;
      }
      
      int res = inf;

      int mitem = find(MARKED.begin(), MARKED.end(), x) - MARKED.begin();
      int mmask = mask;
      cout << "x is " << x << " at " << mitem << endl;
      if (mitem != MARKED.size()) {
	mmask = mask & (~( 1<<mitem ));
	
	if (mask != mmask) {
	  cout << "get " <<  x << " from " << mmask << endl;
	  res = min(D[x][mmask], res);
	}
      }
      
      for (int submask=0; submask < (1<<m); submask ++) {
	if ((mask & submask) != submask) continue;
	int mask1 = mask & submask;
	int mask2 = mask & (~submask);
	if (!mask1 || !mask2) continue;
	//mask1 = mmask & mask1;
	//mask2 = mmask & mask2;
	
	int b1 = inf;
	int b2 = inf;
	
	for (int y=0; y < n; y++) b1 = min(b1, dist[x][y] + D[y][mask1]);
	for (int y=0; y < n; y++) b2 = min(b2, dist[x][y] + D[y][mask2]);
	res = min(res, b1 + b2);
      }
      cout << x << " " << res << endl;
      D[x][mask] = res;
    }


    for (int x=0; x <n; x++) {
      for (int y=0; y <n; y++) {
	D[y][mask] = min(D[y][mask], D[x][mask] + dist[y][x]);
      }
    }
  }

  /*
  int res = inf;
  for (int x=0; x < n; x ++) {
    res = min(res, D[x][(1<<m)-1]);
  }
  cout << res << endl;
  */
  int res = D[MARKED[0]][(1<<m)-1];
  if (res >= inf) cout << -1 << endl;
  else cout << res << endl;
}
/*
cteam053@acm ~ $ ./king < k2.in 
0 1 2 1 1 2 2 2 2  0
2 0 1 1 1 1 2 2 2  1
1 2 0 2 1 1 2 2 2  2
2 1 2 0 1 2 1 1 2  3
2 2 1 2 0 1 1 1 1  4
2 2 2 1 2 0 2 1 1  5
1 2 2 2 1 2 0 1 2  6
2 1 2 2 2 1 2 0 1 
1 2 1 2 2 2 1 2 0 
mask 1
mask 2
mask 3
x is 0 at 1
get 0 from 1
0 2
x is 1 at 3
1 4
x is 2 at 2
2 3
x is 3 at 3
3 3
x is 4 at 3
4 3
x is 5 at 3
5 4
x is 6 at 0
get 6 from 2
6 1
x is 7 at 3
7 4
x is 8 at 3
8 2
mask 4
mask 5
x is 0 at 1
0 4
x is 1 at 3
1 3
x is 2 at 2
get 2 from 1
2 2
x is 3 at 3
3 3
x is 4 at 3
4 2
x is 5 at 3
5 4
x is 6 at 0
get 6 from 4
6 2
x is 7 at 3
7 4
x is 8 at 3
8 2
mask 6
x is 0 at 1
get 0 from 4
0 2
x is 1 at 3
1 3
x is 2 at 2
get 2 from 2
2 1
x is 3 at 3
3 4
x is 4 at 3
4 3
x is 5 at 3
5 4
x is 6 at 0
6 3
x is 7 at 3
7 4
x is 8 at 3
8 2
mask 7
x is 0 at 1
get 0 from 5
0 3
x is 1 at 3
1 4
x is 2 at 2
get 2 from 3
2 3
x is 3 at 3
3 4
x is 4 at 3
4 3
x is 5 at 3
5 5
x is 6 at 0
get 6 from 6
6 3
x is 7 at 3
7 5
x is 8 at 3
8 3
3
*/
